## fife 0.4.1

=== CMakeLists.txt ===
#------------------------------------------------------------------------------
#                                 Fifengine                                          
#------------------------------------------------------------------------------

cmake_minimum_required (VERSION 2.6)

project (fifengine)

#------------------------------------------------------------------------------
#                                 Version                                          
#------------------------------------------------------------------------------

set (FIFE_MAJOR_VERSION 0)
set (FIFE_MINOR_VERSION 4)
set (FIFE_PATCH_VERSION 1)

set(FIFE_VERSION ${FIFE_MAJOR_VERSION}.${FIFE_MINOR_VERSION}.${FIFE_PATCH_VERSION})

configure_file (
  "${PROJECT_SOURCE_DIR}/engine/core/version.h.in"
  "${PROJECT_SOURCE_DIR}/engine/core/version.h"
)

#------------------------------------------------------------------------------
#                                 Options                                          
#------------------------------------------------------------------------------

option(opengl           "Enable OpenGL support"                                 ON)
option(fifechan         "Enable Fifechan GUI subsystem"                         ON)
option(librocket        "Enable Librocket GUI subsystem"                        OFF)
option(cegui            "Enable Crazy Eddie's GUI subsystem"                    OFF)
option(zip              "Enable ZIP archive support"                            ON)
option(logging          "Enable logging"                                        ON)
option(rend-camzone     "Enable camera zone renderer"                           OFF)
option(rend-grid        "Enable camera grid renderer"                           OFF)
option(use-githash      "Try to determine the git hash for the current commit"  ON)
option(build-python     "Build the python extension module"                     ON)
option(build-library    "Build and install files to directly develop with c++"  OFF)

#------------------------------------------------------------------------------
#                                 Configure                                          
#------------------------------------------------------------------------------

# set path to our custom CMAKE scripts
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")

# Create a "Release" build by default.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Select build type. Options are: 'Debug', 'Release', 'RelWithDebInfo' and 'MinSizeRel'."
    FORCE
  )
  message(STATUS "Set CMAKE_BUILD_TYPE to default '${CMAKE_BUILD_TYPE}'.")
endif(NOT CMAKE_BUILD_TYPE)

# if building a C++ library is enabled, then build a shared library by default
# if you need a static library, set "-Dbuild-library=ON -DBUILD_SHARED_LIBS=OFF"
if(build-library)
  set(BUILD_SHARED_LIBS ON CACHE BOOL "Build a shared or static library")
endif(build-library)

# Do not allow an in-source-tree build, request an out-of-source-tree build.
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "#Please build outside of the source tree!\n                        
                       Make a separate folder for building and run CMake there:\n
                       mkdir _build; cd _build; cmake ..\n
                       Before that, cleanup:\nrm -rf CMakeCache.txt CMakeFiles")
endif()

# Do not allow the build directory to be in the source directory for older
# versions of cmake.
if (${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_BINARY_DIR} MATCHES "^${CMAKE_SOURCE_DIR}")
  message(FATAL_ERROR "# Please chose a different build directory.\n
    In cmake versions < 3 SWIG does not work well when the build directory is
    placed inside the source directory.
    Use something like this:\n
        mkdir ../_build; cd ../_build; cmake ../fifengine\n
    You can remove your current build folder.")
endif()

# Disable in-source builds and modifications to the source tree.
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

# organize targets into folders
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

#------------------------------------------------------------------------------
#                                 Compiler Options                                         
#------------------------------------------------------------------------------

if(WIN32)

  if(MSVC)

    # ensure we use minimal "windows.h" lib without the crazy min max macros    
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"WIN32_LEAN_AND_MEAN\"")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"NOMINMAX\"")

    # disable SAFESEH - to avoid "LNK2026: module unsafe" on "OpenAL32.lib"
    SET(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} /D \"SAFESEH:NO\"")
    SET(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} /SAFESEH:NO")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /SAFESEH:NO")
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} /SAFESEH:NO")

    # use static libs - to avoid "LNK1104: cannot open file 'libboost_filesystem-vc140-mt-1_59.lib'"
    set(Boost_USE_STATIC_LIBS ON)     
    set(Boost_USE_MULTITHREADED ON)

  endif(MSVC)

endif(WIN32)

# defines

# define for using TinyXML with Standard Template Library (STL) support enabled
add_definitions(-DTIXML_USE_STL)

#------------------------------------------------------------------------------
#                                 Display Status                                         
#------------------------------------------------------------------------------

message("")
message("== Building FIFE version ${FIFE_VERSION} using build type '${CMAKE_BUILD_TYPE}'.")
message(STATUS "    Source directory is '${PROJECT_SOURCE_DIR}'.")
message(STATUS "    Build  directory is '${PROJECT_BINARY_DIR}'.")
message(STATUS "    Installation path is '${CMAKE_INSTALL_PREFIX}' (set -DCMAKE_INSTALL_PREFIX=<path> to change).")
message(STATUS "    CXX Compiler Flags: '${CMAKE_CXX_FLAGS}'.")
message(STATUS "    Dependencies folder: '${PROJECT_SOURCE_DIR}/../fifengine-dependencies'.")
message("")

#------------------------------------------------------------------------------
#                           Find Dependencies - Windows                                        
#------------------------------------------------------------------------------

# Tell CMake where to search for binaries (dlls), includes and libs on Windows
if(WIN32)
  set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH}

    # help to find dependencies on Appveyor

    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/build-tools/swig"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/bin"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/include"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/include/SDL2"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/include/OpenAL"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/lib"

    # help to find dependencies on your local env (FifeSDK)

    "${PROJECT_SOURCE_DIR}/../swig"
    "${PROJECT_SOURCE_DIR}/../python"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/bin"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/boost"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/lib"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/lib/boost"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/SDL2"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/OpenAL"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/lib"
    
  )
endif(WIN32)

#------------------------------------------------------------------------------
#                                 Source Files                                         
#------------------------------------------------------------------------------

# tell compiler to search in the following folders for include files
include_directories("${PROJECT_BINARY_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/engine/core")
include_directories("${PROJECT_SOURCE_DIR}")

# Core
set (FIFE_CORE_SRC
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundclip.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundclipmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundemitter.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/controller/engine.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/controller/enginesettings.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/eventchannel/eventmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/ext/glee/GLee.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/audio/ogg_loader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/audio/sounddecoder_ogg.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/animationloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/atlasloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/maploader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/objectloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/percentdonelistener.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/video/imageloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/video/resourceanimationloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/model.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/action.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/object.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/timeprovider.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/cellgrid.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/hexgrid.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/squaregrid.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/cell.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/cellcache.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/instance.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/instancetree.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/layer.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/location.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/map.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/renderernode.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/trigger.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/triggercontroller.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/route.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/routepather/multilayersearch.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/routepather/routepather.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/routepather/routepathersearch.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/routepather/singlelayersearch.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/savers/native/map/mapsaver.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/base/exception.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/base/fifeclass.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/base/stringutils.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/log/logger.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/math/angles.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/resource/resource.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/time/timeevent.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/time/timemanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/time/timer.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/directoryprovider.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/fife_boost_filesystem.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/vfs.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/vfsdirectory.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/vfssource.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/vfssourceprovider.cpp

=== dependencies/CMakeLists.txt ===
#------------------------------------------------------------------------------
#                           Fifengine Dependencies                                               
#------------------------------------------------------------------------------

CMAKE_MINIMUM_REQUIRED(VERSION 3.5)

PROJECT(fifengine-dependencies)

set(CMAKE_INSTALL_PREFIX    ${CMAKE_SOURCE_DIR}/../../${PROJECT_NAME}/includes)
set(CMAKE_MODULE_PATH       ${CMAKE_SOURCE_DIR}/../cmake)
set(CMAKE_VERBOSE_MAKEFILE  ON)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set (CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}" CACHE PATH "default install path" FORCE )
endif()

message(STATUS "\nWelcome!\n== Build System for ${PROJECT_NAME}")

# create a "Release" build by default
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Select build type. Options are: 'Debug', 'Release', 'RelWithDebInfo' and 'MinSizeRel'."
    FORCE
  )  
  message(STATUS "Set CMAKE_BUILD_TYPE to default '${CMAKE_BUILD_TYPE}'.")
endif(NOT CMAKE_BUILD_TYPE)

# set a fallback download folder for dependencies ("dependencies/../../${PROJECT_NAME}/downloads")
if(NOT DEPENDENCY_DOWNLOAD_DIR)
    set(DEPENDENCY_DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../${PROJECT_NAME}/downloads)
    message("   DEPENDENCY_DOWNLOAD_DIR not set. Using default.")
endif(NOT DEPENDENCY_DOWNLOAD_DIR)

# set a fallback installation folder for dependencies ("dependencies/../../${PROJECT_NAME}/includes")
if(NOT DEPENDENCY_INSTALL_DIR)
    set(DEPENDENCY_INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../${PROJECT_NAME}/includes)
    message("   DEPENDENCY_INSTALL_DIR not set. Using default.")    
endif(NOT DEPENDENCY_INSTALL_DIR)

# set a fallback folder for the extracted dependencies ("dependencies/../../${PROJECT_NAME}/extracted")
if(NOT DEPENDENCY_EXTRACT_DIR)
    set(DEPENDENCY_EXTRACT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../${PROJECT_NAME}/extracted)
    message("   DEPENDENCY_EXTRACT_DIR not set. Using default.")    
endif(NOT DEPENDENCY_EXTRACT_DIR)

#------------------------------------------------------------------------------
#                                 Display Status                                         
#------------------------------------------------------------------------------

message("")
message("== Config Overview")
message("")
message("   CMAKE_BUILD_TYPE           |  ${CMAKE_BUILD_TYPE}")
message("   CMAKE_BINARY_DIR           |  ${CMAKE_BINARY_DIR}")
message("   CMAKE_INSTALL_PREFIX       |  ${CMAKE_INSTALL_PREFIX}")
message("   DEPENDENCY_INSTALL_DIR     |  ${DEPENDENCY_INSTALL_DIR}") 
message("   DEPENDENCY_DOWNLOAD_DIR    |  ${DEPENDENCY_DOWNLOAD_DIR}") 
message("   DEPENDENCY_EXTRACT_DIR     |  ${DEPENDENCY_EXTRACT_DIR}") 
message("")

#------------------------------------------------------------------------------
#                                Options                                                   
#------------------------------------------------------------------------------

OPTION(FIFE_DEPENDENCY_SDL2          "Download and build dependency: SDL2"       ON)
OPTION(FIFE_DEPENDENCY_SDL2_IMAGE    "Download and build dependency: SDL2_IMAGE" ON)
OPTION(FIFE_DEPENDENCY_SDL2_TTF      "Download and build dependency: SDL2_TTF"   ON)
# TODO boost
OPTION(FIFE_DEPENDENCY_ZLIB          "Download and build dependency: ZLIB"       ON)
OPTION(FIFE_DEPENDENCY_LIBPNG        "Download and build dependency: LIBPNG"     ON)
OPTION(FIFE_DEPENDENCY_OPENAL        "Download and build dependency: OPENAL"     ON)
OPTION(FIFE_DEPENDENCY_SWIG          "Download and build dependency: SWIG"       ON)
OPTION(FIFE_DEPENDENCY_TINYXML       "Download and build dependency: TINYXML"    ON)
OPTION(FIFE_DEPENDENCY_LIBOGG        "Download and build dependency: LIBOGG"     ON)
OPTION(FIFE_DEPENDENCY_LIBVORBIS     "Download and build dependency: LIBVORBIS"  ON)
OPTION(FIFE_DEPENDENCY_FIFECHAN      "Download and build dependency: FIFECHAN"   ON)

#------------------------------------------------------------------------------
#                   Check Options + Include external build scripts                                             
#------------------------------------------------------------------------------

IF(FIFE_DEPENDENCY_SDL2)
    INCLUDE(get-sdl2)
ENDIF(FIFE_DEPENDENCY_SDL2)

IF(FIFE_DEPENDENCY_SDL2_IMAGE)
    INCLUDE(get-sdl2_image)
ENDIF(FIFE_DEPENDENCY_SDL2_IMAGE)

IF(FIFE_DEPENDENCY_SDL2_TTF)
    INCLUDE(get-sdl2_ttf)
ENDIF(FIFE_DEPENDENCY_SDL2_TTF)

# TODO: boost

IF(FIFE_DEPENDENCY_ZLIB)
    INCLUDE(get-zlib)
ENDIF(FIFE_DEPENDENCY_ZLIB)

IF(FIFE_DEPENDENCY_LIBPNG)
    INCLUDE(get-libpng)
ENDIF(FIFE_DEPENDENCY_LIBPNG)

IF(FIFE_DEPENDENCY_OPENAL)
    INCLUDE(get-openal)
ENDIF(FIFE_DEPENDENCY_OPENAL)

IF(FIFE_DEPENDENCY_SWIG)
    INCLUDE(get-swig)
ENDIF(FIFE_DEPENDENCY_SWIG)

IF(FIFE_DEPENDENCY_TINYXML)
    INCLUDE(get-tinyxml)
ENDIF(FIFE_DEPENDENCY_TINYXML)

IF(FIFE_DEPENDENCY_LIBOGG)
    INCLUDE(get-libogg)
ENDIF(FIFE_DEPENDENCY_LIBOGG)

IF(FIFE_DEPENDENCY_LIBVORBIS)
    INCLUDE(get-libvorbis)
ENDIF(FIFE_DEPENDENCY_LIBVORBIS)

IF(FIFE_DEPENDENCY_FIFECHAN)
    INCLUDE(get-fifechan)
ENDIF(FIFE_DEPENDENCY_FIFECHAN)

=== cmake/patches/libvorbis/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(LIBVORBIS C)

message("CMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}")
message("OGG_LIBRARY=${OGG_LIBRARY}")
message("OGG_INCLUDE_DIR=${OGG_INCLUDE_DIR}")

#find_package(Ogg REQUIRED)

include_directories(
    ${OGG_INCLUDE_DIR}
    ${PROJECT_SOURCE_DIR}/lib
)

set(LIBVORBIS_SOURCE
    lib/analysis.c
    #lib/barkmel.c  # unnecessary: bark scale utility
    lib/bitrate.c
    lib/block.c
    lib/codebook.c
    lib/envelope.c
    lib/floor0.c
    lib/floor1.c
    lib/info.c
    lib/lookup.c
    lib/lpc.c
    lib/lsp.c
    lib/mapping0.c
    lib/mdct.c
    lib/psy.c
    #lib/psytune.c   # dead code
    lib/registry.c
    lib/res0.c
    lib/sharedbook.c
    lib/smallft.c
    lib/synthesis.c
    #lib/tone.c      # error: 'M_PI': undeclared identifier
    lib/vorbisenc.c
    lib/window.c
)

SET(libvorbis_HEADER
    lib/backends.h
    lib/bitrate.h
    lib/codebook.h
    lib/codec_internal.h
    lib/envelope.h
    lib/modes/floor_all.h
    lib/books/floor/floor_books.h
    lib/highlevel.h
    lib/lookup.h
    lib/lookup_data.h
    lib/lpc.h
    lib/lsp.h
    lib/masking.h
    lib/mdct.h
    lib/misc.h
    lib/os.h
    lib/psy.h
    lib/modes/psych_11.h
    lib/modes/psych_16.h
    lib/modes/psych_44.h
    lib/modes/psych_8.h
    lib/registry.h
    lib/books/coupled/res_books_stereo.h
    lib/books/uncoupled/res_books_uncoupled.h
    lib/modes/residue_16.h
    lib/modes/residue_44.h
    lib/modes/residue_44u.h
    lib/modes/residue_8.h
    lib/scales.h
    lib/modes/setup_11.h
    lib/modes/setup_16.h
    lib/modes/setup_22.h
    lib/modes/setup_32.h
    lib/modes/setup_44.h
    lib/modes/setup_44u.h
    lib/modes/setup_8.h
    lib/modes/setup_X.h
    lib/smallft.h
    lib/window.h
)

if(WIN32 AND NOT MINGW)
    set(vorbis_defs     win32/vorbis.def)
    set(vorbisfile_defs win32/vorbisfile.def)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

add_library(vorbis             SHARED ${LIBVORBIS_SOURCE} ${LIBVORBIS_HEADER} ${vorbis_defs})
add_library(vorbisfile         SHARED lib/vorbisfile.c ${vorbisfile_defs})
add_library(vorbisfile_static  STATIC lib/vorbisfile.c ${vorbisfile_defs})

if(UNIX)
    set(PLATFORM_LIBS m)
endif(UNIX)

target_link_libraries(vorbis            ${OGG_LIBRARY} ${PLATFORM_LIBS})
target_link_libraries(vorbisfile vorbis ${OGG_LIBRARY})

if(NOT WIN32)
    set_target_properties(vorbisfile_static PROPERTIES OUTPUT_NAME vorbisfile)
endif(NOT WIN32)

install(TARGETS vorbis vorbisfile
    RUNTIME DESTINATION bin
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
)

install(DIRECTORY include/vorbis DESTINATION include FILES_MATCHING PATTERN "*.h")

=== debian/changelog ===
fife (0.4.1-2build1) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:13:23 +0000

fife (0.4.1-2) unstable; urgency=medium

  * Team upload.
  * Stop building fife on mips and mipsel due to architecture limitations which
    cause FTBFS and prevent newer versions from migrating to testing.
    Add alpha to WEAK_HOSTS and hope it builds again.

 -- Markus Koschany <apo@debian.org>  Wed, 19 Jul 2017 22:54:31 +0200

fife (0.4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.4.1.
  * Add get-orig-source target.
  * Declare compliance with Debian Policy 4.0.0.
  * Tighten build-dependency on libfifechan-dev to >= 0.1.4.
  * Use https for Format field.
  * Change homepage link to http://www.fifengine.net/. (Closes: #854620)

 -- Markus Koschany <apo@debian.org>  Fri, 07 Jul 2017 11:26:24 +0200

=== debian/control ===
Source: fife
Uploaders:
 Christoph Egger <christoph@debian.org>
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Section: libdevel
Priority: optional
Build-Depends:
 cmake,
 debhelper (>= 10),
 dh-python,
 glee-dev,
 libalut-dev,
 libasound2-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-regex-dev,
 libboost-test-dev,
 libfifechan-dev (>= 0.1.4),
 libopenal-dev,
 libpng-dev,
 libsdl2-image-dev,
 libsdl2-ttf-dev,
 libsdl2-dev,
 libtinyxml-dev,
 libunittest++-dev,
 libvorbis-dev,
 libxcursor-dev,
 python-all-dev (>= 2.6.6-3~),
 swig,
 zlib1g-dev
X-Python-Version: >= 2.6
Standards-Version: 4.0.0
Vcs-Git: https://anonscm.debian.org/git/pkg-games/fife.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/fife.git
Homepage: http://www.fifengine.net/

Package: python-fife
Section: python
Architecture: amd64 arm64 armel armhf i386 mips64el ppc64el s390x alpha hppa hurd-i386 kfreebsd-any m68k powerpc powerpcspe ppc64 sh4 sparc64 x32
Depends:
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Breaks:
 unknown-horizons (<< 2013.1),
 ${python:Breaks}
Description: FIFE is a multi-platform isometric game engine
 FIFE stands for Flexible Isometric Free Engine and is a cross
 platform game creation framework written in C++. It provides you with
 the ability to create a game using Python interfaces. FIFE also comes
 as a DLL or static library so you can use C++ as well.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
WEAK_HOSTS := alpha

ifneq (,$(findstring $(DEB_HOST_ARCH),$(WEAK_HOSTS)))
	MAX  := 1
	TYPE := MinSizeRel
else
	MAX  := 2
	TYPE := RelWithDebInfo
endif

%:
	dh $@ --max-parallel=$(MAX) --with python2 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=$(TYPE)

override_dh_install:
	dh_install --fail-missing
	find debian/ -name "LICENSE.md" -delete

get-orig-source:
	uscan --download-current-version --force-download

## fife 0.4.1+git20180904

=== CMakeLists.txt ===
#------------------------------------------------------------------------------
#                                 Fifengine                                          
#------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.2.2)

project(fifengine C CXX)

#------------------------------------------------------------------------------
#                                 Version                                          
#------------------------------------------------------------------------------

set(FIFE_MAJOR_VERSION 0)
set(FIFE_MINOR_VERSION 4)
set(FIFE_PATCH_VERSION 1)
set(FIFE_VERSION_SHORT ${FIFE_MAJOR_VERSION}.${FIFE_MINOR_VERSION}.${FIFE_PATCH_VERSION})

# check if "git" is installed
find_program(GIT_TOOL git DOC "Git version control")
mark_as_advanced(GIT_TOOL)

# get git commit hash, if source folder is a git repository
find_file(GIT_DIR NAMES .git PATHS ${CMAKE_SOURCE_DIR} NO_DEFAULT_PATH)

if(GIT_TOOL AND GIT_DIR)
  execute_process(
    COMMAND git rev-parse --short=7 HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  set(FIFE_GIT_HASH ${GIT_COMMIT_HASH})
  unset(GIT_DIR)
else()
  # not a git repo, possibly a source download
  set(FIFE_GIT_HASH "")
endif()

if(GIT_COMMIT_HASH)
  set(FIFE_VERSION ${FIFE_VERSION_SHORT}+build.${FIFE_GIT_HASH})
else()
  set(FIFE_VERSION ${FIFE_VERSION_SHORT})
endif()

message("== Updating version.h with version information and git meta data.")

configure_file (
  "${PROJECT_SOURCE_DIR}/engine/core/version.h.in"
  "${PROJECT_SOURCE_DIR}/engine/core/version.h"
)

#------------------------------------------------------------------------------
#                                 Options                                          
#------------------------------------------------------------------------------

option(opengl           "Enable OpenGL support"                                 ON)
option(fifechan         "Enable Fifechan GUI subsystem"                         ON)
option(librocket        "Enable Librocket GUI subsystem"                        OFF)
if(UNIX AND NOT APPLE)
  option(cegui            "Enable Crazy Eddie's GUI subsystem"                    OFF)
else()
  option(cegui            "Enable Crazy Eddie's GUI subsystem"                    ON)
endif()
option(logging          "Enable logging"                                        ON)
option(build-python     "Build the python extension module"                     ON)
option(build-library    "Build and install files to directly develop with c++"  OFF)

#------------------------------------------------------------------------------
#                                 Configure                                          
#------------------------------------------------------------------------------

# set path to our custom CMAKE scripts
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")

# Create a "Release" build by default.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Select build type. Options are: 'Debug', 'Release', 'RelWithDebInfo' and 'MinSizeRel'."
    FORCE
  )
  message(STATUS "Set CMAKE_BUILD_TYPE to default '${CMAKE_BUILD_TYPE}'.")
endif(NOT CMAKE_BUILD_TYPE)

# if building a C++ library is enabled, then build a shared library by default
# if you need a static library, set "-Dbuild-library=ON -DBUILD_SHARED_LIBS=OFF"
if(build-library)
  set(BUILD_SHARED_LIBS ON CACHE BOOL "Build a shared or static library")
endif(build-library)

# Do not allow an in-source-tree build, request an out-of-source-tree build.
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "#Please build outside of the source tree!\n                        
                       Make an out-of-source-tree folder for building and run CMake there:\n
                       mkdir ../_build; cd ../_build; cmake ../fifengine\n
                       Before that, cleanup:\nrm -rf CMakeCache.txt CMakeFiles")
endif()

# Disable in-source builds and modifications to the source tree.
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

# organize targets into folders
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

#------------------------------------------------------------------------------
#                                 Compiler Options                                         
#------------------------------------------------------------------------------

# MSVC compiler options
if(WIN32 AND MSVC)
  # build on all cores
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /nologo")

  if(CMAKE_BUILD_TYPE STREQUAL "Release")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W0 /O2")   
  else()
    # warning level: /W<level 0 to 4> or /Wall
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /Od")   
  endif()
  
  # ensure we use minimal "windows.h" lib without the crazy min max macros    
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"WIN32_LEAN_AND_MEAN\"")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"NOMINMAX\"")

  # avoid "C1128: number of sections exceeded object file format limit: compile with /bigobj"
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")

  # disable SAFESEH - to avoid "LNK2026: module unsafe" on "OpenAL32.lib"
  set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} /D /SAFESEH:NO")
  set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} /SAFESEH:NO")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /SAFESEH:NO")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} /SAFESEH:NO")

  # use static libs - to avoid "LNK1104: cannot open file 'libboost_filesystem-vc140-mt-1_59.lib'"
  set(Boost_USE_STATIC_LIBS ON)     
  set(Boost_USE_MULTITHREADED ON)

  # Note: c++11 is implicitly enabled on MSVC >=2013
endif()

# GCC and Clang compiler options
if("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU" OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
  set(CMAKE_CXX_FLAGS "-std=c++11 -fPIC ${CMAKE_CXX_FLAGS}")  

  if(CMAKE_BUILD_TYPE STREQUAL "Release")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2 -Wno-error")    
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g2 -Wall -Wextra -Wunused")
  endif()
endif()

#------------------------------------------------------------------------------
#                                 Defines                                        
#------------------------------------------------------------------------------

# define for using TinyXML with Standard Template Library (STL) support enabled
add_definitions(-DTIXML_USE_STL)

if(logging)
  add_definitions(-DLOG_ENABLED)
endif(logging)

if(opengl)  
  add_definitions(-DHAVE_OPENGL)
endif(opengl)

if(cegui)
  add_definitions(-DHAVE_CEGUI)
endif(cegui)

#------------------------------------------------------------------------------
#                                 Display Status                                         
#------------------------------------------------------------------------------

message("")
message("== Building FIFE version ${FIFE_VERSION} using build type '${CMAKE_BUILD_TYPE}'.")
message(STATUS "    Source directory is '${PROJECT_SOURCE_DIR}'.")
message(STATUS "    Build  directory is '${PROJECT_BINARY_DIR}'.")
message(STATUS "    Installation path is '${CMAKE_INSTALL_PREFIX}' (set -DCMAKE_INSTALL_PREFIX=<path> to change).")
message(STATUS "    Dependencies folder: '${PROJECT_SOURCE_DIR}/../fifengine-dependencies'.")
message("")
message(STATUS "    CMake version is '${CMAKE_VERSION}'.")
message(STATUS "    CXX Compiler ID: '${CMAKE_CXX_COMPILER_ID}'.")
message(STATUS "    CXX Compiler Flags: '${CMAKE_CXX_FLAGS}'.")
message("")

#------------------------------------------------------------------------------
#                           Find Dependencies - Windows                                        
#------------------------------------------------------------------------------

# Tell CMake where to search for binaries (dlls), includes and libs on Windows
if(WIN32)
  set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH}

    # help to find dependencies on Appveyor

    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/build-tools/swig"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/bin"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/include"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/include/SDL2"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/include/AL"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/lib"

    # help to find dependencies on your local env (FifeSDK)

    "${PROJECT_SOURCE_DIR}/../swig"
    "${PROJECT_SOURCE_DIR}/../python"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/bin"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/boost"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/lib"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/lib/boost"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/SDL2"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/AL"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/lib"
    
  )
endif(WIN32)

#------------------------------------------------------------------------------
#                                 Source Files                                         
#------------------------------------------------------------------------------

# tell compiler to search in the following folders for include files
include_directories("${PROJECT_BINARY_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/engine/core")
include_directories("${PROJECT_SOURCE_DIR}")

# Core
set(FIFE_CORE_SRC
  ${PROJECT_SOURCE_DIR}/engine/core/audio/actionaudio.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundclip.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundclipmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundemitter.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundsource.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/effects/soundeffect.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/effects/soundeffectmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/effects/soundfilter.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/controller/engine.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/controller/enginesettings.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/eventchannel/eventmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/eventchannel/joystick/joystick.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/eventchannel/joystick/joystickmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/audio/ogg_loader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/audio/sounddecoder_ogg.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/input/controllermappingloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/animationloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/atlasloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/maploader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/objectloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/percentdonelistener.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/video/imageloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/video/resourceanimationloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/model.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/action.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/object.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/timeprovider.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/cellgrid.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/hexgrid.cpp

=== debian/changelog ===
fife (0.4.1+git20180904-2) unstable; urgency=medium

  * Team upload.
  * Build the Python 3 version of fife from now on.

 -- Markus Koschany <apo@debian.org>  Thu, 06 Sep 2018 15:05:18 +0200

fife (0.4.1+git20180904-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.4.1+git20180904.
  * Remove glee-dev from Build-Depends. Build-depend on libglew-dev instead.
  * Switch to compat level 11.
  * Declare compliance with Debian Policy 4.2.1.
  * Build for any again and try to avoid memory exhaustion by using -g1 on 32
    bit architectures. (Closes: #718274)
  * Use new dh_missing override.

 -- Markus Koschany <apo@debian.org>  Tue, 04 Sep 2018 15:08:24 +0200

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,16 @@
 Priority: optional
 Build-Depends:
  cmake,
- debhelper (>= 10),
+ debhelper (>= 11),
  dh-python,
- glee-dev,
  libalut-dev,
  libasound2-dev,
  libboost-dev,
  libboost-filesystem-dev,
  libboost-regex-dev,
  libboost-test-dev,
- libfifechan-dev (>= 0.1.4),
+ libfifechan-dev (>= 0.1.4+git20180904),
+ libglew-dev,
  libopenal-dev,
  libpng-dev,
  libsdl2-image-dev,
@@ -25,21 +25,21 @@
  libunittest++-dev,
  libvorbis-dev,
  libxcursor-dev,
- python-all-dev (>= 2.6.6-3~),
+ python3-dev,
+ python3,
  swig,
  zlib1g-dev
-X-Python-Version: >= 2.6
-Standards-Version: 4.0.0
+Standards-Version: 4.2.1
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/fife.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/fife.git
 Homepage: http://www.fifengine.net/
 
-Package: python-fife
+Package: python3-fife
 Section: python
-Architecture: amd64 arm64 armel armhf i386 mips64el ppc64el s390x alpha hppa hurd-i386 kfreebsd-any m68k powerpc powerpcspe ppc64 sh4 sparc64 x32
+Architecture: any
 Depends:
  ${misc:Depends},
- ${python:Depends},
+ ${python3:Depends},
  ${shlibs:Depends}
 Breaks:
  unknown-horizons (<< 2013.1),

## fife 0.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 set(FIFE_MAJOR_VERSION 0)
 set(FIFE_MINOR_VERSION 4)
-set(FIFE_PATCH_VERSION 1)
+set(FIFE_PATCH_VERSION 2)
 set(FIFE_VERSION_SHORT ${FIFE_MAJOR_VERSION}.${FIFE_MINOR_VERSION}.${FIFE_PATCH_VERSION})
 
 # check if "git" is installed
@@ -56,11 +56,7 @@
 option(opengl           "Enable OpenGL support"                                 ON)
 option(fifechan         "Enable Fifechan GUI subsystem"                         ON)
 option(librocket        "Enable Librocket GUI subsystem"                        OFF)
-if(UNIX AND NOT APPLE)
-  option(cegui            "Enable Crazy Eddie's GUI subsystem"                    OFF)
-else()
-  option(cegui            "Enable Crazy Eddie's GUI subsystem"                    ON)
-endif()
+option(cegui            "Enable Crazy Eddie's GUI subsystem"                    OFF)
 option(logging          "Enable logging"                                        ON)
 option(build-python     "Build the python extension module"                     ON)
 option(build-library    "Build and install files to directly develop with c++"  OFF)
@@ -261,3 +257,5 @@
   ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/timeprovider.cpp
   ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/cellgrid.cpp
   ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/hexgrid.cpp
+  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/squaregrid.cpp
+  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/cell.cpp

=== dependencies/CMakeLists.txt ===
--- 
+++ 
@@ -65,10 +65,11 @@
 OPTION(FIFE_DEPENDENCY_SDL2          "Download and build dependency: SDL2"       ON)
 OPTION(FIFE_DEPENDENCY_SDL2_IMAGE    "Download and build dependency: SDL2_IMAGE" ON)
 OPTION(FIFE_DEPENDENCY_SDL2_TTF      "Download and build dependency: SDL2_TTF"   ON)
+OPTION(FIFE_DEPENDENCY_GLEW          "Download and build dependency: GLEW"       ON)
 # TODO boost
 OPTION(FIFE_DEPENDENCY_ZLIB          "Download and build dependency: ZLIB"       ON)
 OPTION(FIFE_DEPENDENCY_LIBPNG        "Download and build dependency: LIBPNG"     ON)
-OPTION(FIFE_DEPENDENCY_OPENAL        "Download and build dependency: OPENAL"     ON)
+OPTION(FIFE_DEPENDENCY_OPENALSOFT    "Download and build dependency: OPENALSOFT" ON)
 OPTION(FIFE_DEPENDENCY_SWIG          "Download and build dependency: SWIG"       ON)
 OPTION(FIFE_DEPENDENCY_TINYXML       "Download and build dependency: TINYXML"    ON)
 OPTION(FIFE_DEPENDENCY_LIBOGG        "Download and build dependency: LIBOGG"     ON)
@@ -91,6 +92,10 @@
     INCLUDE(get-sdl2_ttf)
 ENDIF(FIFE_DEPENDENCY_SDL2_TTF)
 
+IF(FIFE_DEPENDENCY_GLEW)
+    INCLUDE(get-glew)
+ENDIF(FIFE_DEPENDENCY_GLEW)
+
 # TODO: boost
 
 IF(FIFE_DEPENDENCY_ZLIB)
@@ -101,9 +106,9 @@
     INCLUDE(get-libpng)
 ENDIF(FIFE_DEPENDENCY_LIBPNG)
 
-IF(FIFE_DEPENDENCY_OPENAL)
-    INCLUDE(get-openal)
-ENDIF(FIFE_DEPENDENCY_OPENAL)
+IF(FIFE_DEPENDENCY_OPENALSOFT)
+    INCLUDE(get-openalsoft)
+ENDIF(FIFE_DEPENDENCY_OPENALSOFT)
 
 IF(FIFE_DEPENDENCY_SWIG)
     INCLUDE(get-swig)

=== cmake/patches/libogg/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(Ogg C)

set(LIBOGG_SRC
    src/bitwise.c
    src/framing.c
)
set(LIBOGG_HEADER
    include/ogg/ogg.h
    include/ogg/os_types.h
)

if(MSVC)
    ADD_DEFINITIONS(/DLIBOGG_EXPORTS /D_UNICODE /DUNICODE)
    LIST(APPEND LIBOGG_SRC win32/ogg.def)
endif(MSVC)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

add_library(ogg SHARED ${LIBOGG_SRC} ${LIBOGG_HEADER})

if(UNIX AND NOT APPLE)
    # create "ogg/config_types.h"
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/include/ogg/config_types.h
        COMMAND ./configure --silent
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

    add_custom_target(config_types SOURCES include/ogg/config_types.h)
    add_dependencies(ogg config_types)

    install(FILES include/ogg/config_types.h DESTINATION include/ogg)

endif(UNIX AND NOT APPLE)

install(TARGETS ogg
    RUNTIME DESTINATION bin
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
)

install(FILES ${LIBOGG_HEADER} DESTINATION include/ogg)

=== cmake/patches/tinyxml/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(TINYXML)

option(BUILD_SHARED_LIBS "Building shared libs. Default is ON" ON)
if(MSVC AND BUILD_SHARED_LIBS)
 set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

add_definitions(-DTIXML_USE_STL=1)

set(TINYXML_SRC
  tinystr.cpp
  tinyxml.cpp
  tinyxmlerror.cpp
  tinyxmlparser.cpp
)

set(TINYXML_HEADERS
  tinystr.h
  tinyxml.h
)

add_library(tinyxml ${TINYXML_SRC})

install(TARGETS tinyxml
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

install(FILES ${TINYXML_HEADERS} DESTINATION include)

=== debian/changelog ===
fife (0.4.2-2) unstable; urgency=medium

  * Team upload.
  * Add debian/patches/0001-sdl2-config.patch (Closes: #951962).
  * Add debian/patches/0002-swig4.patch (Closes: #953016).
  * Remove all Breaks.
    - "unknown-horizons (<< 2013.1)" is not even in oldoldstable.
    - ${python:Breaks} (or ${python3:Breaks}) is undefined.
  * Switch to debhelper-compat 12. Remove file debian/compat.
  * Add Rules-Requires-Root: no.
  * Use HTTPS in Homepage.
  * Declare compliance with Debian Policy 4.5.0.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Sun, 29 Mar 2020 16:59:10 +0300

fife (0.4.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.4.2.
  * Tighten B-D on libfifechan-dev.
  * Declare compliance with Debian Policy 4.3.0.
  * Use canonical VCS URI.

 -- Markus Koschany <apo@debian.org>  Mon, 14 Jan 2019 21:07:03 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Priority: optional
 Build-Depends:
  cmake,
- debhelper (>= 11),
+ debhelper-compat (= 12),
  dh-python,
  libalut-dev,
  libasound2-dev,
@@ -14,7 +14,7 @@
  libboost-filesystem-dev,
  libboost-regex-dev,
  libboost-test-dev,
- libfifechan-dev (>= 0.1.4+git20180904),
+ libfifechan-dev (>= 0.1.5),
  libglew-dev,
  libopenal-dev,
  libpng-dev,
@@ -29,10 +29,11 @@
  python3,
  swig,
  zlib1g-dev
-Standards-Version: 4.2.1
-Vcs-Git: https://anonscm.debian.org/git/pkg-games/fife.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/fife.git
-Homepage: http://www.fifengine.net/
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
+Vcs-Git: https://salsa.debian.org/games-team/fife.git
+Vcs-Browser: https://salsa.debian.org/games-team/fife
+Homepage: https://www.fifengine.net/
 
 Package: python3-fife
 Section: python
@@ -41,9 +42,6 @@
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends}
-Breaks:
- unknown-horizons (<< 2013.1),
- ${python:Breaks}
 Description: FIFE is a multi-platform isometric game engine
  FIFE stands for Flexible Isometric Free Engine and is a cross
  platform game creation framework written in C++. It provides you with

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

MAX  := 2
TYPE := RelWithDebInfo

ifeq (32,$(DEB_HOST_ARCH_BITS))
ifeq (,$(filter $(DEB_HOST_ARCH), i386))
	MAX  := 1
	TYPE := Release
	export DEB_CFLAGS_MAINT_APPEND = -g1
	export DEB_CXXFLAGS_MAINT_APPEND = -g1
endif
endif

%:
	dh $@ --max-parallel=$(MAX) --with python3 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=$(TYPE) \
		-DPYTHON_EXECUTABLE="/usr/bin/python3"

override_dh_install:
	dh_install
	find debian/ -name "LICENSE.md" -delete

override_dh_missing:
	dh_missing --fail-missing
